﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using System;

public class Patator : MonoBehaviour {
	public GameObject patator;
	public GameObject dialog;

	private int chiffreMin;
	private int chiffreMax;
	public GameObject inputChiffreMin;
	public GameObject inputChiffreMax;

	public GameObject cestPlus;
	public GameObject cestMoins;
	public GameObject cestMonChiffre;

	private int chiffreDemande=-1;
	private bool tournerPatator = false;

	private Color colorGrey=new Color(1,1,1,0.5f);
	private Color colorWhite=new Color(1,1,1,1);

	// Use this for initialization
	void Start () {
		lancerJeu ();
	}
	
	// Update is called once per frame
	void Update () {
		if (chiffreDemande != -1) {
			//print ("["+chiffreMin+":"+chiffreMax+"]");
			if (Input.GetKeyDown (KeyCode.DownArrow)) { // Jeu terminé
				chiffreDemande = -1;
				changeDialog ("Ouai ! J'ai trouvé !\nJe trouve toujours de toute façon...");
				tournerPatator=true;

				cestPlus.SetActive (false);
				cestMoins.SetActive (false);
				cestMonChiffre.SetActive (false);
			}
			if (Input.GetKey (KeyCode.DownArrow)) {
				FindChild (cestMonChiffre.name, "Texte").GetComponent<Text> ().color = colorWhite;
				FindChild (cestMonChiffre.name, "Touche").GetComponent<RawImage> ().color = colorWhite;
			} else {
				FindChild (cestMonChiffre.name, "Texte").GetComponent<Text> ().color = colorGrey;
				FindChild (cestMonChiffre.name, "Touche").GetComponent<RawImage> ().color = colorGrey;
			}


			if (Input.GetKeyDown (KeyCode.LeftArrow)) { // C'est moins
				chiffreMax = chiffreDemande;
				chiffreDemande = (chiffreMax - chiffreMin) / 2 + chiffreMin;
				demander (chiffreDemande);
			}
			if (Input.GetKey (KeyCode.LeftArrow)) {
				FindChild (cestMoins.name, "Texte").GetComponent<Text> ().color = colorWhite;
				FindChild (cestMoins.name, "Touche").GetComponent<RawImage> ().color = colorWhite;
			} else {
				FindChild (cestMoins.name, "Texte").GetComponent<Text> ().color = colorGrey;
				FindChild (cestMoins.name, "Touche").GetComponent<RawImage> ().color = colorGrey;
			}

			if (Input.GetKeyDown (KeyCode.RightArrow)) { // C'est plus
				chiffreMin = chiffreDemande;
				chiffreDemande = (chiffreMax - chiffreMin) / 2 + chiffreMin;
				demander (chiffreDemande);
			}
			if (Input.GetKey (KeyCode.RightArrow)) {
				FindChild (cestPlus.name, "Texte").GetComponent<Text> ().color = colorWhite;
				FindChild (cestPlus.name, "Touche").GetComponent<RawImage> ().color = colorWhite;
			} else {
				FindChild (cestPlus.name, "Texte").GetComponent<Text> ().color = colorGrey;
				FindChild (cestPlus.name, "Touche").GetComponent<RawImage> ().color = colorGrey;
			}
		}
		if(tournerPatator){
			patator.transform.Rotate (0, 5, 0);
		}
	}


	public void lancerJeu(){
		chiffreMin = int.Parse(inputChiffreMin.GetComponent<InputField>().text);
		chiffreMax = int.Parse(inputChiffreMax.GetComponent<InputField>().text);
		print ("[" + chiffreMin + ":" + chiffreMax + "]");

		tournerPatator = false;
		patator.transform.rotation = Quaternion.identity;

		changeDialog ("Bonjour, je suis Patator !\nChoisi secrètement un chiffre entre " + chiffreMin + " et " + chiffreMax + " et je vais essayer de le deviner en te posant quelques questions...");
		setTimeout (() => {
			chiffreDemande = UnityEngine.Random.Range ((chiffreMax - chiffreMin) / 2 - chiffreMax / 20, (chiffreMax - chiffreMin) / 2 + chiffreMax / 20);
			demander (chiffreDemande);
			cestPlus.SetActive (true);
			cestMoins.SetActive (true);
			cestMonChiffre.SetActive (true);
		}, 5);
	}


	public void setTimeout(Action action,float seconds){
		StartCoroutine(_wait(seconds, action));
	}

	IEnumerator _wait(float time, Action callback){
		yield return new WaitForSeconds(time);
		callback();
	}

	public void changeDialog(string text){
		for (int i = 0; i < text.Length; i++) {
			float iTime = (float)(0.02 * i);
			string textSubstring = text.Substring (0, i);
			setTimeout( () => {
				dialog.GetComponent<TextMesh>().text = textSubstring;
			}, iTime);
		}
	}

	public void demander(int chiffre){
		changeDialog ("Est-ce que ton chiffre est plus grand ou plus petit que "+chiffre+" ??");
	}
	
	private GameObject FindChild(string pRoot, string pName){
		Transform pTransform = GameObject.Find(pRoot).GetComponent<Transform>();
		foreach (Transform trs in pTransform) {
			if (trs.gameObject.name == pName)
				return trs.gameObject;
		}
		return null;
	}

}
